;; $Id: dbprocdr.dsl 0.1 1997/07/31 14:51:33 nwalsh Exp $

;; ============================= PROCEDURES =============================

(define (PROCSTEP ilvl)
  (if (> ilvl 1) 2.0em 1.8em))

(define ($hierarch-number-format depth)
  (case (modulo depth 5)
    ((1) "1")
    ((2) "a")
    ((3) "i")
    ((4) "A")
    (else "I")))

(define ($hierarch-number$ nd seperator)
  (if (equal? (gi nd) "STEP")
      (string-append
       (format-number
	(child-number nd) 
	($hierarch-number-format ($proc-step-depth$ nd)))
       seperator)
      ""))

(define ($proc-step-depth$ nd)
  (let loop ((step nd) (depth 0))
    (if (equal? (gi step) "PROCEDURE")
	depth
	(loop (parent step) 
	      (if (equal? (gi step) "STEP")
		  (+ depth 1)
		  depth)))))

(define ($proc-step-number$ nd)
  (let* ((step (if (equal? (gi nd) "STEP") nd (parent nd)))
	 (str ($hierarch-number$ step "")))
    (string-append str (gentext-label-title-sep "STEP"))))

(define ($proc-step-xref-number$ nd)
  (let loop ((step nd) (str "") (first #t))
    (if (equal? (gi step) "PROCEDURE")
	str
	(loop (parent step) 
	      (if (equal? (gi step) "STEP")
		  (string-append 
		   ($hierarch-number$ step
				      (if first
					  ""
					  (gentext-intra-label-sep "STEP")))
		   str)
		  str)
	      (if (equal? (gi step) "STEP")
		  #f
		  first)))))
 

(element PROCEDURE 
  (let ((titles (select-elements (children (current-node)) "TITLE")))
    (make element gi: "DIV"
	  attributes: (list
		       (list "CLASS" (gi)))
	  (if (not (node-list-empty? titles))
	      (make element gi: "P"
		    (make element gi: "B"
			  (with-mode admon-caption-mode
			    (process-first-descendant "TITLE"))))
	      (empty-sosofo))
	  (make element gi: "OL"
		attributes: (list
			     (list "TYPE" ($hierarch-number-format 1)))
		(process-children)))))

(element (PROCEDURE TITLE) (empty-sosofo))

(element SUBSTEPS
  (make element gi: "OL"
	attributes: (list
		     (list "CLASS" "SUBSTEPS")
		     (list "TYPE" ($hierarch-number-format
				   (+ ($proc-step-depth$ (current-node)) 1))))
	(process-children)))

(element STEP
  (let ((id (attribute-string "ID")))
    (make sequence
      (make element gi: "LI"
	    (if id
		(make element gi: "A"
		      attributes: (list
				   (list "NAME" id))
		      (empty-sosofo))
		(empty-sosofo))
	    (process-children)))))


